123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354 |
- #!/usr/bin/env bash
- set -x
- set -eo pipefail
- if ! [ -x "$(command -v psql)" ]; then
- echo >&2 "Error: `psql` is not installed."
- echo >&2 "install using brew: brew install libpq."
- echo >&2 "link to /usr/local/bin: brew link --force libpq ail"
- exit 1
- fi
- if ! [ -x "$(command -v sqlx)" ]; then
- echo >&2 "Error: `sqlx` is not installed."
- echo >&2 "Use:"
- echo >&2 " cargo install --version=^0.5.6 sqlx-cli --no-default-features --features postgres"
- echo >&2 "to install it."
- exit 1
- fi
- if [[ -z "${SKIP_DOCKER}" ]]
- then
- RUNNING_POSTGRES_CONTAINER=$(docker ps --filter 'name=postgres' --format '{{.ID}}')
- if [[ -n $RUNNING_POSTGRES_CONTAINER ]]; then
- echo >&2 "there is a postgres container already running, kill it with"
- echo >&2 " docker kill ${RUNNING_POSTGRES_CONTAINER}"
- exit 1
- fi
- docker run \
- --name="flowy" \
- -e POSTGRES_USER=${DB_USER} \
- -e POSTGRES_PASSWORD=${DB_PASSWORD} \
- -e POSTGRES_DB=${DB_NAME} \
- -p "${DB_PORT}":5432 \
- -d postgres \
- postgres -N 1000
- fi
- # Keep pinging Postgres until it's ready to accept commands
- until PGPASSWORD="${DB_PASSWORD}" psql -h "${DB_HOST}" -U "${DB_USER}" -p "${DB_PORT}" -d "postgres" -c '\q'; do
- >&2 echo "Postgres is still unavailable - sleeping"
- sleep 1
- done
- >&2 echo "Postgres is up and running on port ${DB_PORT} - running migrations now!"
- export DATABASE_URL=postgres://${DB_USER}:${DB_PASSWORD}@localhost:${DB_PORT}/${DB_NAME}
- sqlx database create
- sqlx migrate run
- >&2 echo "Postgres has been migrated, ready to go!"
|